.386
.model flat, stdcall
option casemap:none

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD
NouvelleEtoile PROTO :DWORD ; New Star
Random PROTO :DWORD

include \masm32\include\gdi32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\windows.inc

includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

.const
  NbEtoiles equ 1000 ; No. Stars
  TailleStructEtoile equ 28 ;Size Struct Star
  VitesseMin equ 1 ; Low Speed or speedmin
  VitesseMax equ 10 ;Max speed or speedmax

.data
  AppName db "win32asm's starfield", 0
  ClassName db "executter_window", 0
  EstNvEtoile db FALSE ;Eastern Star Nv
  Vitesse dd 2 ;speed
  AfficheTraine db TRUE ;Drive type displayed or Displays Trolling

.data?
  Xfenetre dd ? ;window
  Yfenetre dd ?
  Xfenetrediv2 dd ?
  Yfenetrediv2 dd ?
  hInstance HINSTANCE ?
  hEtoiles HANDLE ? ;H Stars
  pEtoiles dd ? ;P Stars
  hArrPlan dd ?
  NombrePrRandom dd ? ;Random Name Pr
  rect RECT <?, ?, ?, ?>

.code
  start:
    invoke GetSystemMetrics, SM_CXSCREEN
    mov Xfenetre, eax
    shr eax, 1
    mov Xfenetrediv2, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    mov Yfenetre, eax
    shr eax, 1
    mov Yfenetrediv2, eax

    invoke GetModuleHandle, NULL
    mov hInstance, eax
    invoke WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
    invoke ExitProcess, eax

    WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
      LOCAL wc:WNDCLASS
      LOCAL Msg:MSG
      LOCAL hWnd:HWND

      mov wc.style, CS_HREDRAW or CS_VREDRAW
      mov wc.lpfnWndProc, OFFSET WndProc
      mov wc.cbClsExtra, NULL
      mov wc.cbWndExtra, NULL
      push hInst
      pop wc.hInstance
      mov wc.hIcon, NULL
      invoke LoadCursor, NULL, IDC_ARROW
      mov wc.hCursor, eax
      invoke GetStockObject, BLACK_BRUSH
      mov hArrPlan, eax
      mov wc.hbrBackground, eax
      mov wc.lpszMenuName, NULL
      mov wc.lpszClassName, OFFSET ClassName
      invoke RegisterClass, ADDR wc
      invoke CreateWindowEx, NULL, OFFSET ClassName, OFFSET AppName, WS_POPUP, 0, 0, Xfenetre, Yfenetre, NULL, NULL, hInst, NULL
      mov hWnd, eax
      invoke ShowWindow, hWnd, SW_SHOWDEFAULT
      invoke UpdateWindow, hWnd
      .WHILE TRUE
        invoke InvalidateRect, hWnd, NULL, FALSE
        invoke GetMessage, ADDR Msg, NULL, NULL, NULL
        .BREAK .IF !eax
        invoke TranslateMessage, ADDR Msg
        invoke DispatchMessage, ADDR Msg
      .ENDW
      mov eax, Msg.wParam
      ret
    WinMain ENDP

    WndProc PROC uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
      LOCAL hDC:HANDLE
      LOCAL hMemDC:HANDLE
      LOCAL hBmp:HANDLE
      LOCAL ps:PAINTSTRUCT

      .IF uMsg == WM_CREATE
        mov rect.left, 0
        mov rect.top, 0
        push Xfenetre
        pop rect.right
        push Yfenetre
        pop rect.bottom
        invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, NbEtoiles * TailleStructEtoile
        mov hEtoiles, eax
        invoke GlobalLock, hEtoiles
        mov pEtoiles, eax
        invoke ShowCursor, FALSE
      .ELSEIF uMsg == WM_DESTROY
        invoke ShowCursor, TRUE
        invoke GlobalUnlock, pEtoiles
        invoke GlobalFree, hEtoiles
        invoke PostQuitMessage, NULL
      .ELSEIF uMsg == WM_KEYDOWN
        .IF wParam == VK_ESCAPE
          invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL
        .ELSEIF wParam == VK_PGDN
          .IF Vitesse != VitesseMin
            dec Vitesse
          .ENDIF
        .ELSEIF wParam == VK_PGUP
          .IF Vitesse != VitesseMax
            inc Vitesse
          .ENDIF
        .ELSEIF wParam == VK_T
          .IF AfficheTraine
            mov AfficheTraine, FALSE
          .ELSE
            mov AfficheTraine, TRUE
          .ENDIF
        .ENDIF
      .ELSEIF uMsg == WM_PAINT
        invoke BeginPaint, hWnd, ADDR ps
        mov hDC, eax
        invoke CreateCompatibleDC, hDC
        mov hMemDC, eax
        invoke CreateCompatibleBitmap, hDC, Xfenetre, Yfenetre
        mov hBmp, eax
        invoke SelectObject, hMemDC, hBmp
        invoke FillRect, hMemDC, OFFSET rect, hArrPlan
        xor ecx, ecx
        .WHILE ecx != NbEtoiles ;NbEtoile=No. Stars
          mov eax, TailleStructEtoile ;TailleStructEtoile=Size Struct Star
          mul ecx
          add eax, pEtoiles
          mov ebx, eax
          ;----------------------------------------------;
          ;--- CHECK IF THE STAR IS ALWAYS GOOD ---;
          mov eax, Vitesse
          .IF dword ptr [ebx + 8] <= eax
            push ecx
            invoke NouvelleEtoile, ebx  ;NouvelleEtoile=New Star
            pop ecx
            mov EstNvEtoile, TRUE
          .ENDIF
          ;----------------------------------------------;
          ;--- REPLACEMENT OF OLD ADDRESS ---;
          .IF AfficheTraine ; AfficheTraine=Displays Trolling or Drive type displayed???
            push dword ptr [ebx + 12]
            pop dword ptr [ebx + 20]
            push dword ptr [ebx + 16]
            pop dword ptr [ebx + 24]
          .ENDIF
          ;----------------------------------------;
          ;--- CALCULATION OF NEW ADDRESS ---;
          mov eax, Vitesse     ; Vitesse = Speed
          sub dword ptr [ebx + 8], eax
          mov eax, dword ptr [ebx]
          shl eax, 8
          cdq
          idiv dword ptr [ebx + 8]
          add eax, Xfenetrediv2
          mov dword ptr [ebx + 12], eax
          mov eax, dword ptr [ebx + 4]
          shl eax, 8
          cdq
          idiv dword ptr [ebx + 8]
          add eax, Yfenetrediv2
          mov dword ptr [ebx + 16], eax
          ;---------------------------;
          ;--- CORRECTION OF BUGS ---;
          .IF AfficheTraine && EstNvEtoile ;Eastern Star Nv
            push dword ptr [ebx + 12]
            pop dword ptr [ebx + 20]
            push dword ptr [ebx + 16]
            pop dword ptr [ebx + 24]
            mov EstNvEtoile, FALSE
          .ENDIF
          ;--------------------------------------------------------------------;
          ;--- CHECK IF THE STAR IS ALWAYS IN THE LIMITS OF THE SCREEN ---;
          mov eax, Xfenetre
          mov edx, Yfenetre    ;fenetre=window
          .IF dword ptr [ebx + 12] < 0 || dword ptr [ebx + 12] > eax || dword ptr [ebx + 16] < 0 || dword ptr [ebx + 16] > edx
            mov dword ptr [ebx + 8], 0
          .ENDIF
          push ecx
          ;---------------------------;
          ;--- COLOR OF THE STAR ---;
          xor eax, eax
          mov ah, cl
          mov al, ah
          shl eax, 8
          mov al, ah
          invoke CreatePen, PS_SOLID, NULL, eax
          push eax
          invoke SelectObject, hMemDC, eax
          ;--------------------------;
          ;--- DRAWING FROM THE STAR ---;
          push NULL
          .IF AfficheTraine
            push dword ptr [ebx + 24]
            push dword ptr [ebx + 20]
          .ELSE
            mov eax, dword ptr [ebx + 16]
            inc eax
            push eax
            push dword ptr [ebx + 12]
          .ENDIF
          push hMemDC
          call MoveToEx
          invoke LineTo, hMemDC, dword ptr [ebx + 12], dword ptr [ebx + 16]
          pop eax
          invoke DeleteObject, eax
          pop ecx
          inc ecx
        .ENDW
        invoke BitBlt, hDC, 0, 0, Xfenetre, Yfenetre, hMemDC, 0, 0, SRCCOPY
        invoke DeleteObject, hBmp
        invoke DeleteDC, hMemDC
        invoke EndPaint, hWnd, ADDR ps
      .ELSE
        invoke DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
      .ENDIF
      xor eax, eax
      ret
    WndProc ENDP

    NouvelleEtoile PROC uses ebx pEtoile:DWORD
      mov ebx, pEtoile
      invoke Random, Xfenetre
      sub eax, Xfenetrediv2
      mov dword ptr [ebx], eax
      invoke Random, Yfenetre
      sub eax, Yfenetrediv2
      mov dword ptr [ebx + 4], eax
      mov dword ptr [ebx + 8], 256
      push Xfenetrediv2
      pop dword ptr [ebx + 12]
      push Yfenetrediv2
      pop dword ptr [ebx + 16]
      mov eax, pEtoile
      ret
    NouvelleEtoile ENDP  ;NouvelleEtoile= New Star

    Random PROC Limite:DWORD
      mov eax, NombrePrRandom
      mov ecx, 23
      mul ecx
      add eax, 7
      and eax, 0FFFFFFFFh
      ror eax, 1
      xor eax, NombrePrRandom
      mov NombrePrRandom, eax
      mov ecx, Limite ;Limit
      xor edx, edx
      div ecx
      mov eax, edx
      ret
    Random ENDP
  end start  